package net.pricefx.common.api;

public enum UserGroupEntitlementType {

	QUOTE("quote", "Q", true),
	CONTRACT("contract", "CT", true),
	REBATEAGREEMENT("rebateAgreement", "RA", true),

	PRICELIST("pricelist", "PL"),
	MANUALPRICELIST("manualPricelist", "MPL"),
	PRICEGRID("priceGrid", "PG"),
	SIMULATION("simulation", "SIM"),

	LOOKUPTABLE("lookupTable", "LT"),
	DATACHANGEREQUEST("dataChangeRequest", "DCR");

	private String typeName;
	private String typeCode;
	private boolean enabledByDefault;

	private UserGroupEntitlementType(String typeName, String typeCode) {
		this(typeName, typeCode, false);
	}

	private UserGroupEntitlementType(String typeName, String typeCode, boolean enabledByDefault) {
		this.typeName = typeName;
		this.typeCode = typeCode;
		this.enabledByDefault = enabledByDefault;
	}

	@Override
	public String toString() {
		return typeName();
	}

	public String typeName() {
		return typeName;
	}
	public String typeCode() {
		return typeCode;
	}
	public boolean enabledByDefault() { return enabledByDefault; }

	public static UserGroupEntitlementType of(String id) {
		for (UserGroupEntitlementType v : values()) {
			if (v.typeName.equals(id))
				return v;
		}
		throw new IllegalArgumentException("Cannot resolve " + id + " in " + UserGroupEntitlementType.class.getName());
	}

	public static UserGroupEntitlementType ofTypeCode(String typeCode) {
		for (UserGroupEntitlementType v : values()) {
			if (v.typeCode.equals(typeCode))
				return v;
		}
		return null;
	}
}