package net.pricefx.logic.core.model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

import static net.pricefx.common.api.InputType.CONFIGURATOR;
import static net.pricefx.common.api.InputType.HIDDEN;
import static net.pricefx.common.api.InputType.INLINECONFIGURATOR;


@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2017-11-10T15:30:45.019+01:00")
public class ContextParameter {

    protected String name = null;
    protected String label = null;
    protected String lookupTableId = null;
    protected String url = null;
    protected String type = null;
    protected Object value = null;
    protected String valueHint = null;
    protected Boolean readOnly = null;
    protected Object filter = null;
    protected String parameterGroup = null;
    protected Boolean required = null;
    protected String labelTranslations = null;
    protected Object parameterConfig = null;
    protected List<Object> valueOptions = new ArrayList<Object>();
    protected Boolean addUnknownValues = null;


    /**
     **/
    public ContextParameter name(String name) {
        this.name = name;
        return this;
    }

    @JsonProperty("name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }


    /**
     **/
    public ContextParameter label(String label) {
        this.label = label;
        return this;
    }

    @JsonProperty("label")
    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }


    /**
     **/
    public ContextParameter lookupTableId(String lookupTableId) {
        this.lookupTableId = lookupTableId;
        return this;
    }

    @JsonProperty("lookupTableId")
    public String getLookupTableId() {
        return lookupTableId;
    }

    public void setLookupTableId(String lookupTableId) {
        this.lookupTableId = lookupTableId;
    }


    /**
     **/
    public ContextParameter url(String url) {
        this.url = url;
        return this;
    }

    @JsonProperty("url")
    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }


    /**
     **/
    public ContextParameter type(String type) {
        this.type = type;
        return this;
    }

    @JsonProperty("type")
    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }


    /**
     **/
    public ContextParameter value(Object value) {
        this.value = value;
        return this;
    }

    @JsonProperty("value")
    public Object getValue() {
        return value;
    }

    public void setValue(Object value) {
        this.value = value;
    }


    /**
     **/
    public ContextParameter valueHint(String valueHint) {
        this.valueHint = valueHint;
        return this;
    }

    @JsonProperty("valueHint")
    public String getValueHint() {
        return valueHint;
    }

    public void setValueHint(String valueHint) {
        this.valueHint = valueHint;
    }


    /**
     **/
    public ContextParameter readOnly(Boolean readOnly) {
        this.readOnly = readOnly;
        return this;
    }

    @JsonProperty("readOnly")
    public Boolean getReadOnly() {
        return readOnly;
    }

    public void setReadOnly(Boolean readOnly) {
        this.readOnly = readOnly;
    }


    /**
     **/
    public ContextParameter filter(Object filter) {
        this.filter = filter;
        return this;
    }

    @JsonProperty("filter")
    public Object getFilter() {
        return filter;
    }

    public void setFilter(Object filter) {
        this.filter = filter;
    }


    /**
     **/
    public ContextParameter parameterGroup(String parameterGroup) {
        this.parameterGroup = parameterGroup;
        return this;
    }

    @JsonProperty("parameterGroup")
    public String getParameterGroup() {
        return parameterGroup;
    }

    public void setParameterGroup(String parameterGroup) {
        this.parameterGroup = parameterGroup;
    }


    /**
     **/
    public ContextParameter required(Boolean required) {
        this.required = required;
        return this;
    }

    @JsonProperty("required")
    public Boolean getRequired() {
        return required;
    }

    public void setRequired(Boolean required) {
        this.required = required;
    }


    /**
     **/
    public ContextParameter labelTranslations(String labelTranslations) {
        this.labelTranslations = labelTranslations;
        return this;
    }

    @JsonProperty("labelTranslations")
    public String getLabelTranslations() {
        return labelTranslations;
    }

    public void setLabelTranslations(String labelTranslations) {
        this.labelTranslations = labelTranslations;
    }


    /**
     **/
    public ContextParameter parameterConfig(Object parameterConfig) {
        this.parameterConfig = parameterConfig;
        return this;
    }

    @JsonProperty("parameterConfig")
    public Object getParameterConfig() {
        return parameterConfig;
    }

    public void setParameterConfig(Object parameterConfig) {
        this.parameterConfig = parameterConfig;
    }


    /**
     **/
    public ContextParameter valueOptions(List<Object> valueOptions) {
        this.valueOptions = valueOptions;
        return this;
    }

    @JsonProperty("valueOptions")
    public List<Object> getValueOptions() {
        return valueOptions;
    }

    public void setValueOptions(List<Object> valueOptions) {
        this.valueOptions = valueOptions;
    }


    /**
     **/
    public ContextParameter addUnknownValues(Boolean addUnknownValues) {
        this.addUnknownValues = addUnknownValues;
        return this;
    }

    @JsonProperty("addUnknownValues")
    public Boolean getAddUnknownValues() {
        return addUnknownValues;
    }

    public void setAddUnknownValues(Boolean addUnknownValues) {
        this.addUnknownValues = addUnknownValues;
    }

    @JsonIgnore
    public boolean isConfigurator() {
        return CONFIGURATOR.name().equals(type) || INLINECONFIGURATOR.name().equals(type);
    }

    @JsonIgnore
    public boolean isHidden() {
        return HIDDEN.name().equals(type);
    }


    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }
        ContextParameter contextParameter = (ContextParameter) o;
        return Objects.equals(this.name, contextParameter.name) &&
                Objects.equals(this.label, contextParameter.label) &&
                Objects.equals(this.lookupTableId, contextParameter.lookupTableId) &&
                Objects.equals(this.url, contextParameter.url) &&
                Objects.equals(this.type, contextParameter.type) &&
                Objects.equals(this.value, contextParameter.value) &&
                Objects.equals(this.valueHint, contextParameter.valueHint) &&
                Objects.equals(this.readOnly, contextParameter.readOnly) &&
                Objects.equals(this.filter, contextParameter.filter) &&
                Objects.equals(this.parameterGroup, contextParameter.parameterGroup) &&
                Objects.equals(this.required, contextParameter.required) &&
                Objects.equals(this.labelTranslations, contextParameter.labelTranslations) &&
                Objects.equals(this.parameterConfig, contextParameter.parameterConfig) &&
                Objects.equals(this.valueOptions, contextParameter.valueOptions) &&
                Objects.equals(this.addUnknownValues, contextParameter.addUnknownValues);
    }

    @Override
    public int hashCode() {
        return Objects.hash(name, label, lookupTableId, url, type, value, valueHint, readOnly, filter, parameterGroup, required, labelTranslations, parameterConfig, valueOptions, addUnknownValues);
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("class ContextParameter {\n");

        sb.append("    name: ").append(toIndentedString(name)).append("\n");
        sb.append("    label: ").append(toIndentedString(label)).append("\n");
        sb.append("    lookupTableId: ").append(toIndentedString(lookupTableId)).append("\n");
        sb.append("    url: ").append(toIndentedString(url)).append("\n");
        sb.append("    type: ").append(toIndentedString(type)).append("\n");
        sb.append("    value: ").append(toIndentedString(value)).append("\n");
        sb.append("    valueHint: ").append(toIndentedString(valueHint)).append("\n");
        sb.append("    readOnly: ").append(toIndentedString(readOnly)).append("\n");
        sb.append("    filter: ").append(toIndentedString(filter)).append("\n");
        sb.append("    parameterGroup: ").append(toIndentedString(parameterGroup)).append("\n");
        sb.append("    required: ").append(toIndentedString(required)).append("\n");
        sb.append("    labelTranslations: ").append(toIndentedString(labelTranslations)).append("\n");
        sb.append("    parameterConfig: ").append(toIndentedString(parameterConfig)).append("\n");
        sb.append("    valueOptions: ").append(toIndentedString(valueOptions)).append("\n");
        sb.append("    addUnknownValues: ").append(toIndentedString(addUnknownValues)).append("\n");
        sb.append("}");
        return sb.toString();
    }

    /**
     * Convert the given object to string with each line indented by 4 spaces
     * (except the first line).
     */
    private String toIndentedString(java.lang.Object o) {
        if (o == null) {
            return "null";
        }
        return o.toString().replace("\n", "\n    ");
    }
}

